//  Persistence of Vision Raytracer V3.1
//  World definition file.
//
//  Contains 1 lights, 6 materials and 27 primitives.
//
//  This file was generated for POV-Ray V3.1 by
//  Moray V3.2 For Windows Copyright (c) 1993-2000 Lutz + Kretzschmar
//

//  Date : 10/14/2000    (14.10.2000)
//

/*
  The text between these two comments is in MorayPOV.INC and is
  automatically included in all POV files that Moray exports.
*/

default {
  texture {
    pigment { rgb <1,0,0> }
  }
}

/* // Scene Comment

This scene was created with Moray V3.2 For Windows.

*/ // End Scene Comment

global_settings {
  adc_bailout 0.003922
  ambient_light <1.0,1.0,1.0>
  assumed_gamma 1.9
  hf_gray_16 off
  irid_wavelength <0.247059,0.176471,0.137255>
  max_intersections 64
  max_trace_level 10
  number_of_waves 10
  radiosity {
    brightness       3.3
    count            100
    distance_maximum 0.0
    error_bound      0.4
    gray_threshold   0.5
    low_error_factor 0.8
    minimum_reuse    0.015
    nearest_count    6
    recursion_limit  1
  }
}

background { color <0.000,0.000,0.000> }

camera {  //  Camera good_angle
  location  <     -3.000,       9.567,     -12.927>
  sky       <    0.00000,     0.00000,     1.00000> // Use right handed-system 
  up        <        0.0,         0.0,         1.0> // Where Z is up
  right     <    1.34982,         0.0,         0.0> // Right Vector is adjusted to compensate for spherical (Moray) vs. planar (POV-Ray) aspect ratio
  angle         32.76878    // Vertical      24.577
  look_at   <     -1.970,      -1.873,       9.712>
  focal_point  <-0.5, 4.0, 0> // was 0.5 Always Lookat
  aperture     0.5 //0.75 //3
  blur_samples 30 //72
  confidence   0.80 //0.9886
  variance     0.002223
}


//    Other cameras are commented out.
/*
camera {  //  Camera camera1
  location  <     -3.000,       4.000,     -12.927>
  sky       <    0.00000,     0.00000,     1.00000> // Use right handed-system 
  up        <        0.0,         0.0,         1.0> // Where Z is up
  right     <    1.33360,         0.0,         0.0> // Right Vector is adjusted to compensate for spherical (Moray) vs. planar (POV-Ray) aspect ratio
  angle          4.21314    // Vertical       3.160
  look_at   <      2.158,      -1.910,       9.094>
}

*/

/*
camera {  //  Camera Straight_on
  location  <      0.000,       7.457,     -12.739>
  sky       <    0.00000,     0.00000,     1.00000> // Use right handed-system 
  up        <        0.0,         0.0,         1.0> // Where Z is up
  right     <    1.36115,         0.0,         0.0> // Right Vector is adjusted to compensate for spherical (Moray) vs. planar (POV-Ray) aspect ratio
  angle         42.04693    // Vertical      31.535
  look_at   <      0.000,       1.645,      -0.206>
}

*/

/*
camera {  //  Camera good_angle_experiment
  location  <     -3.000,       9.567,     -12.927>
  sky       <    0.00000,     0.00000,     1.00000> // Use right handed-system 
  up        <        0.0,         0.0,         1.0> // Where Z is up
  right     <    1.34672,         0.0,         0.0> // Right Vector is adjusted to compensate for spherical (Moray) vs. planar (POV-Ray) aspect ratio
  angle         29.62544    // Vertical      22.219
  look_at   <     -0.597,      -2.020,       9.556>
  // Focal blur settings
  //focal_point  <-0.597, -2.020, 9.556> // Always Lookat
  focal_point  <-0.5, 4.0, 0.5> // Always Lookat
  aperture     0.75 //3
  blur_samples 72
  confidence   0.9886
  variance     0.002223
}
*/
//
// ******** Debugging objects *********
//
//
//sphere {// <-1.970, -1.873, 9.712>, 0.1
//<-0.5, 4.0, 0.5>, 0.1
//  color rgb <1.0, 0.0, 0.0> }



//
// *******  L I G H T S *******
//

light_source {   // Light001
  <0.0, 0.0, 0.0>
  color rgb <1.000, 1.000, 1.000>
  translate  <4.85118, 0.0, -6.994724>
}


//
// ********  MATERIALS  *******
//

#include "testtube2.inc"


//############## Macros ##############
#macro Make_Bubble (X,Y,Z,Diameter)
sphere {
  <0,0,0>,1
  material {
    Plasmoid
  }
  scale Diameter
  translate  <X, Y, Z>
}       
#end
#declare BubbleCount=0;
#declare BubbleMass = union {
#while(BubbleCount < 50)
        #local RX = seed(BubbleCount);
        #local RY = seed(BubbleCount *50);
        #local RZ = seed(BubbleCount *5);
        #local RD = seed(BubbleCount *120);
         
        #local X = (rand(RX) + 0.307313 );// - 0.5;
        #local Y = (rand(RY) + 2.7274);// - 0.5;
        #local Z = (rand(RZ) + 0.149203);// / 10;
        #local Diameter = (rand(RD) + 0.1) / 10;
        Make_Bubble(X, Y, Z, Diameter)


        #declare BubbleCount=BubbleCount+1;
#end
} 



//
// ********  OBJECTS  *******
//

#declare First_Saying = union {
  text {   // Reality_is_a_
    ttf      "C:\WINDOWS\Fonts\Arial.ttf",
    "Reality is a",
    0.1,  // Depth
    <0.0,     0.0, 0.0> // Offset
    material {
      MetalStand
    }
    rotate <0.0, -0.0, -0.0>
    translate  <-2.727535, 7.6, 0.0>
  }

  text {   // consensual_
    ttf      "C:\WINDOWS\Fonts\Arial.ttf",
    "consensual",
    0.1,  // Depth
    <0.0,     0.0, 0.0> // Offset
    rotate <-2.0, -0.0, -0.0>
    translate  <-2.922359, 6.82401, 0.0>
  }

  text {   // hallucination
    ttf      "C:\WINDOWS\Fonts\Arial.ttf",
    "hallucination",
    0.1,  // Depth
    <0.0,     0.0, 0.0> // Offset
    rotate <-4.0, -0.0, -0.0>
    translate  <-2.9873, 5.91483, 0.0>
  }

  translate  <-0.2, 0.75, 0.0>
}
#declare Second_Saying = union {
  text {   // The
    ttf      "C:\WINDOWS\Fonts\Arial.ttf",
    "The",
    0.1,  // Depth
    <0.0,     0.0, 0.0> // Offset
    rotate -10.0*x
    translate  <-3.182124, 5.3, 0.0>
  }

  text {   // alphanumeric
    ttf      "C:\WINDOWS\Fonts\Arial.ttf",
    "alphanumeric",
    0.1,  // Depth
    <0.0,     0.0, 0.0> // Offset
    rotate -10.0*x
    translate  <-3.25, 4.545891, 0.0>
  }

  text {   // character_is_our
    ttf      "C:\WINDOWS\Fonts\Arial.ttf",
    "character is our",
    0.1,  // Depth
    <0.0,     0.0, 0.0> // Offset
    rotate -12.0*x
    translate  <-3.0, 3.65, 0.0>
  }

  text {   // basic_atomic_unit
    ttf      "C:\WINDOWS\Fonts\Arial.ttf",
    "basic atomic unit",
    0.1,  // Depth
    <0.0,     0.0, 0.0> // Offset
    scale 0.9
    rotate -14.0*x
    translate  <-3.3, 2.8, 0.0>
  }

}
#declare Third_Saying = union {
  text {   // we_live_in_a_
    ttf      "C:\WINDOWS\Fonts\Arial.ttf",
    "We live in a ",
    0.1,  // Depth
    <0.0,     0.0, 0.0> // Offset
    rotate -18.0*x
    translate  <-2.208004, 1.03, 0.0>
  }

  text {   // laboritory
    ttf      "C:\WINDOWS\Fonts\Arial.ttf",
    "laboritory",
    0.1,  // Depth
    <0.0,     0.0, 0.0> // Offset
    scale 1.2
    rotate -20.0*x
    translate  <-2.0, 0.02988, 0.0>
  }

  scale 1.2
  translate  <-0.3, -0.39, 0.0>
}
union { // all_text
  object { First_Saying }
  object { Second_Saying }
  object { Third_Saying }
  material {
    Text
  }
  scale 0.26
  rotate <-0.0, -200.205612, -0.0>
  translate  <3.317597, -2.0, -3.08887>
}




merge {  // stand_joint
  sphere { <0.4000, 0.4000, 0.4000>, 0.1000 }
  sphere { <0.4000, -0.4000, 0.4000>, 0.1000 }
  sphere { <-0.4000, -0.4000, 0.4000>, 0.1000 }
  sphere { <-0.4000, 0.4000, 0.4000>, 0.1000 }
  sphere { <0.4000, 0.4000, -0.4000>, 0.1000 }
  sphere { <0.4000, -0.4000, -0.4000>, 0.1000 }
  sphere { <-0.4000, -0.4000, -0.4000>, 0.1000 }
  sphere { <-0.4000, 0.4000, -0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, 0.4000>, <-0.4000, 0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, -0.4000, 0.4000>, <-0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, -0.4000, -0.4000>, <-0.4000, -0.4000, -0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, -0.4000>, <-0.4000, 0.4000, -0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, -0.4000>, <0.4000, 0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, -0.4000, -0.4000>, <0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <-0.4000, -0.4000, -0.4000>, <-0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <-0.4000, 0.4000, -0.4000>, <-0.4000, 0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, 0.4000>, <0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, -0.4000>, <0.4000, -0.4000, -0.4000>, 0.1000 }
  cylinder { <-0.4000, 0.4000, -0.4000>, <-0.4000, -0.4000, -0.4000>, 0.1000 }
  cylinder { <-0.4000, 0.4000, 0.4000>, <-0.4000, -0.4000, 0.4000>, 0.1000 }
  box { <-0.4000, -0.4000, -0.5000> <0.4000, 0.4000, 0.5000> }
  box { <-0.4000, -0.5000, -0.4000> <0.4000, 0.5000, 0.4000> }
  box { <-0.5000, -0.4000, -0.4000> <0.5000, 0.4000, 0.4000> }
// Attributes returned success!
  material {
    MetalStand
  }
  scale <0.3, 0.4, 0.4>
  translate  <0.0, 4.85, 4.2>
}


union { // STAND
  cylinder { // standpole
    <0,0,1>, <0,0,0>, 1 
    material {
      MetalStand
    }
    scale <0.1, 0.1, 14.0>
    rotate -90.0*x
    translate  <0.0, -8.0, 4.2>
  }
  torus { // stand_clasp
    1.05, 0.05  rotate -x*90
    material {
      MetalStand
    }
    rotate -90.0*x
    translate  3.8*y
  }
  cylinder { // stand_cross_bar
    <0,0,1>, <0,0,0>, 1 
    material {
      MetalStand
    }
    scale <0.05, 0.05, 3.3>
    translate  <0.0, 3.8, 1.0>
  }
}


box { // texture_preview
  <-1, -1, -1>, <1, 1, 1>
  material {
    Plasmoid
  }
  scale <1.0, 1.0, 0.01>
  rotate 30.0*x
  translate  <0.0, 6.0, 10.0>
}


union { // scene
  sphere { // Sphere002
    <0,0,0>,1
    material {
      DryGrass
    }
    scale 990.0
    translate  1005.0*z
  }
}


#declare out_tube = merge {
  cylinder { // Cylndr001
    <0,0,1>, <0,0,0>, 1 
    material {
      S_Glass
    }
    scale <1.0, 1.0, 5.0>
    rotate -90.0*x
  }
  sphere { // Sphere001
    <0,0,0>,1
    material {
      S_Glass
    }
  }
}
#declare inside_tube = merge {
  cylinder { // Cylndr002
    <0,0,1>, <0,0,0>, 1 
    material {
      S_Glass
    }
    scale <1.0, 1.0, 7.0>
    rotate -90.0*x
    translate  3.0*y
  }
  scale 0.9
}
#declare CSG001 = difference {
  object { out_tube }
  object { inside_tube }
  material {
    Crystal
  }
}
#declare Green_Goo = merge {
  cylinder { // Cylndr003
    <0,0,1>, <0,0,0>, 1 
    material {
      Plasmoid
    }
    scale <1.0, 1.0, 3.0>
    rotate -90.0*x
  }
  sphere { // Sphere004
    <0,0,0>,1
    material {
      Plasmoid
    }
  }
  material {
    Plasmoid
  }
  scale 0.9
}
#declare green_goo_with_hole = difference {
  object { Green_Goo }
  cylinder { // Cylndr004
    <0,0,1>, <0,0,0>, 1 
    material {
      S_Glass
    }
    scale <0.2, 0.2, 20.0>
    rotate <-85.0, -15.0, -15.0>
    translate  <-0.3, 0.0, -0.3>
  }
  object { BubbleMass translate <-1,-1,-1> }
  object { BubbleMass rotate 160*y translate <-1.0,-3,0.5>}
}

intersection { // Bubbles inside test tube outside of goop
        union {
                object { BubbleMass rotate 60*y translate <-0.5,0,0>}
                object { BubbleMass rotate 120*y translate <-1.0,0,0.5>}
        }
        cylinder { <0,0,2>, <0,0,1>, 1 scale <1.0, 1.0, 3.0> rotate -90.0*x material { Plasmoid } scale 0.9}
}

#declare bubble = sphere {
       <0,0,0>,0.2 material { S_Glass }
}

union { // TestTubeGroup
  torus { // Torus001
    1.1, 0.1  rotate -x*90
    material {
      Crystal
    }
    rotate -90.0*x
    translate  5.0*y
  }
  object { CSG001 }
  difference {
        object { green_goo_with_hole }
        sphere { bubble } //translate <0,4,3> }
  }
}





torus { // stand_clasp2
  1.05, 0.05  rotate -x*90
  material {
    MetalStand
  }
  rotate -90.0*x
  translate  4.85*y
}


cylinder { // stand_cross_bar1
  <0,0,1>, <0,0,0>, 1 
  material {
    MetalStand
  }
  scale <0.05, 0.05, 3.3>
  translate  <0.0, 4.85, 1.0>
}


merge {  // stand_joint1
  sphere { <0.4000, 0.4000, 0.4000>, 0.1000 }
  sphere { <0.4000, -0.4000, 0.4000>, 0.1000 }
  sphere { <-0.4000, -0.4000, 0.4000>, 0.1000 }
  sphere { <-0.4000, 0.4000, 0.4000>, 0.1000 }
  sphere { <0.4000, 0.4000, -0.4000>, 0.1000 }
  sphere { <0.4000, -0.4000, -0.4000>, 0.1000 }
  sphere { <-0.4000, -0.4000, -0.4000>, 0.1000 }
  sphere { <-0.4000, 0.4000, -0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, 0.4000>, <-0.4000, 0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, -0.4000, 0.4000>, <-0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, -0.4000, -0.4000>, <-0.4000, -0.4000, -0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, -0.4000>, <-0.4000, 0.4000, -0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, -0.4000>, <0.4000, 0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, -0.4000, -0.4000>, <0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <-0.4000, -0.4000, -0.4000>, <-0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <-0.4000, 0.4000, -0.4000>, <-0.4000, 0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, 0.4000>, <0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, -0.4000>, <0.4000, -0.4000, -0.4000>, 0.1000 }
  cylinder { <-0.4000, 0.4000, -0.4000>, <-0.4000, -0.4000, -0.4000>, 0.1000 }
  cylinder { <-0.4000, 0.4000, 0.4000>, <-0.4000, -0.4000, 0.4000>, 0.1000 }
  box { <-0.4000, -0.4000, -0.5000> <0.4000, 0.4000, 0.5000> }
  box { <-0.4000, -0.5000, -0.4000> <0.4000, 0.5000, 0.4000> }
  box { <-0.5000, -0.4000, -0.4000> <0.5000, 0.4000, 0.4000> }
// Attributes returned success!
  material {
    MetalStand
  }
  scale <0.3, 0.4, 0.4>
  translate  <0.0, 3.8, 4.2>
}


cylinder { // glass_rod
  <0,0,1>, <0,0,0>, 1 
  material {
    S_Glass
  }
  scale <0.2, 0.2, 20.0>
  rotate <-85.0, -15.0, -15.0>
  translate  <-0.36782, 0.0, -0.286436>
}

//#declare my_matrix =  intersection {
//        plane { x, 3 }
//        plane { z, 0 }
//}

//object { my_matrix  color rgbf <1,0,0,0.95>  }
//plane { z, 3 }



